Imports System.Math

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.Name = "Form1"
        Me.Text = "Form1"

    End Sub

#End Region

    Private m_Cx As Single
    Private m_Cy As Single
    Private m_Radius As Single

    Private m_Drawing As Boolean
    Private m_X1 As Single
    Private m_Y1 As Single
    Private m_X2 As Single
    Private m_Y2 As Single

    Private m_NumIntersections As Integer
    Private m_IX1 As Single
    Private m_IY1 As Single
    Private m_IX2 As Single
    Private m_IY2 As Single

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Use double-buffering to reduce flicker.
        Me.SetStyle( _
                ControlStyles.AllPaintingInWmPaint Or _
                ControlStyles.UserPaint Or _
                ControlStyles.DoubleBuffer, _
                True)
        Me.UpdateStyles()

        StartOver()
    End Sub

    Private Function FindLineCircleIntersections(ByVal cx As Single, ByVal cy As Single, ByVal radius As Single, ByVal x1 As Single, ByVal y1 As Single, ByVal x2 As Single, ByVal y2 As Single, ByRef ix1 As Single, ByRef iy1 As Single, ByRef ix2 As Single, ByRef iy2 As Single) As Integer
        Dim dx As Single
        Dim dy As Single
        Dim A As Single
        Dim B As Single
        Dim C As Single
        Dim det As Single
        Dim t As Single

        dx = x2 - x1
        dy = y2 - y1

        A = dx * dx + dy * dy
        B = 2 * (dx * (x1 - cx) + dy * (y1 - cy))
        C = (x1 - cx) * (x1 - cx) + (y1 - cy) * (y1 - cy) - radius * radius

        det = B * B - 4 * A * C
        If (A <= 0.0000001) Or (det < 0) Then
            ' No real solutions.
            Return 0
        ElseIf det = 0 Then
            ' One solution.
            t = -B / (2 * A)
            ix1 = x1 + t * dx
            iy1 = y1 + t * dy
            Return 1
        Else
            ' Two solutions.
            t = (-B + Sqrt(det)) / (2 * A)
            ix1 = x1 + t * dx
            iy1 = y1 + t * dy
            t = (-B - Sqrt(det)) / (2 * A)
            ix2 = x1 + t * dx
            iy2 = y1 + t * dy
            Return 2
        End If
    End Function

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        e.Graphics.Clear(Me.BackColor)
        e.Graphics.DrawEllipse(Pens.Blue, m_Cx - m_Radius, m_Cy - m_Radius, m_Radius * 2, m_Radius * 2)

        ' Draw the segment.
        e.Graphics.DrawLine(Pens.BlueViolet, m_X1, m_Y1, m_X2, m_Y2)

        ' Draw the intersections (if we have them).
        Select Case m_NumIntersections
            Case 0
            Case 1
                e.Graphics.FillRectangle(Brushes.Red, m_IX1 - 2, m_IY1 - 2, 4, 4)
            Case 2
                e.Graphics.FillRectangle(Brushes.Red, m_IX1 - 2, m_IY1 - 2, 4, 4)
                e.Graphics.FillRectangle(Brushes.Red, m_IX2 - 2, m_IY2 - 2, 4, 4)
        End Select
    End Sub

    Private Sub Form1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        m_Drawing = True
        m_NumIntersections = 0
        m_X1 = e.X
        m_Y1 = e.Y
        m_X2 = e.X
        m_Y2 = e.Y
        Me.Invalidate()
    End Sub

    Private Sub Form1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseMove
        If Not m_Drawing Then Exit Sub
        m_X2 = e.X
        m_Y2 = e.Y
        Me.Invalidate()
    End Sub

    Private Sub Form1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseUp
        m_Drawing = False

        ' Find and draw the intersections.
        Dim gr As Graphics = Me.CreateGraphics()
        m_NumIntersections = FindLineCircleIntersections(m_Cx, m_Cy, m_Radius, m_X1, m_Y1, m_X2, m_Y2, m_IX1, m_IY1, m_IX2, m_IY2)
        Me.Invalidate()
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        StartOver()
    End Sub

    Private Sub StartOver()
        m_Cx = Me.ClientSize.Width / 2
        m_Cy = Me.ClientSize.Height / 2
        If m_Cx > m_Cy Then
            m_Radius = m_Cy * 0.9
        Else
            m_Radius = m_Cx * 0.9
        End If
        Debug.WriteLine(m_Cx & ", " & m_Cy & ", " & m_Radius)
        Me.Invalidate()
    End Sub
End Class
